"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ensureHtmlWebackPlugin = ensureHtmlWebackPlugin;
exports.getHtmlWebpackPlugin = getHtmlWebpackPlugin;

var _importFrom = _interopRequireDefault(require("import-from"));

var _lodash = require("lodash");

var _playgroundHtml = require("../../../shared/playgroundHtml");

var _shared = require("./shared");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(source, true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(source).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function ensureHtmlWebackPlugin({
  rootDir
}, plugins) {
  if ((0, _shared.hasPlugin)(plugins, 'HtmlWebpackPlugin')) {
    return plugins.map(plugin => isHtmlWebpackPlugin(plugin) ? changeHtmlPluginFilename(plugin) : plugin);
  }

  const htmlWebpackPlugin = getHtmlWebpackPlugin(rootDir);

  if (!htmlWebpackPlugin) {
    return plugins;
  }

  return [...plugins, new htmlWebpackPlugin({
    title: 'React Cosmos',
    filename: _playgroundHtml.RENDERER_FILENAME
  })];
}

function getHtmlWebpackPlugin(rootDir) {
  return _importFrom.default.silent(rootDir, 'html-webpack-plugin');
}

function isHtmlWebpackPlugin(plugin) {
  return (0, _shared.isInstanceOfPlugin)(plugin, 'HtmlWebpackPlugin');
}

function changeHtmlPluginFilename(htmlPlugin) {
  if (htmlPlugin.options.filename !== 'index.html') {
    return htmlPlugin;
  }

  const safeOptions = (0, _lodash.omit)(htmlPlugin.options, 'chunks');
  return new htmlPlugin.constructor(_objectSpread({}, safeOptions, {
    filename: _playgroundHtml.RENDERER_FILENAME
  }));
}