"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.getUserModules = getUserModules;

var _path = _interopRequireDefault(require("path"));

var _ = require(".");

var _slash = require("../slash");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

async function getUserModules({
  rootDir,
  fixturesDir,
  fixtureFileSuffix
}) {
  const {
    fixturePaths,
    decoratorPaths
  } = await (0, _.findUserModulePaths)({
    rootDir,
    fixturesDir,
    fixtureFileSuffix
  });
  return {
    fixtureExportsByPath: getDefaultExportsByPath(fixturePaths, rootDir),
    decoratorsByPath: getDefaultExportsByPath(decoratorPaths, rootDir)
  };
}

function getDefaultExportsByPath(paths, rootDir) {
  const exportsByPath = {};
  paths.forEach(p => {
    const relPath = (0, _slash.slash)(_path.default.relative(rootDir, p));
    exportsByPath[relPath] = require(p).default;
  });
  return exportsByPath;
}