"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.startWebServer = startWebServer;

var _httpProxy = require("./plugins/httpProxy");

var _openFile = require("./plugins/openFile");

var _userDepsFile = require("./plugins/userDepsFile");

var _webpack = require("./plugins/webpack");

var _cli = require("./shared/cli");

var _devServer = require("./shared/devServer");

async function startWebServer() {
  const plugins = [_openFile.openFile, _webpack.webpackDevServer, _httpProxy.httpProxy];

  if (shouldGenerateUserDepsFile()) {
    plugins.push(_userDepsFile.userDepsFile);
  }

  await (0, _devServer.startDevServer)('web', plugins);
}

function shouldGenerateUserDepsFile() {
  // CLI support for --external-userdeps flag
  return Boolean((0, _cli.getCliArgs)().externalUserdeps);
}